package darkomen.util;

import java.io.IOException;
import java.io.InputStream;
import java.io.StringWriter;

/**
 *
 * @author Gabriel Kind
 */
public class Registry {
    /**
     *
     * @param location path in the registry
     * @param key registry key
     * @return registry value or null if not found
     */
    public static final String readRegistry(String location, String key){
        try {
            // Run reg query, then read output with StreamReader (internal class)
            Process process = Runtime.getRuntime().exec("reg query " +
                    '"'+ location + "\" /v " + key);

            StreamReader reader = new StreamReader(process.getInputStream());
            reader.start();
            process.waitFor();
            reader.join();
            String output = reader.getResult();

            // Output has the following format:
            // \n<Version information>\n\n<key>\t<registry type>\t<value>
            //System.out.println(output);
            
            if (output.contains("\t"))
            {
                String[] parsed = output.split("\t");
                return parsed[parsed.length-1].trim();
            }
            else if (output.contains("    "))
            {
                String[] parsed = output.split("    ");
                return parsed[parsed.length-1].trim();
            }
            else
            {
                return null;
            }
        }
        catch (Exception e) {
            System.out.println("upps");
            return null;
        }

    }

    static class StreamReader extends Thread {
        private InputStream is;
        private StringWriter sw= new StringWriter();

        public StreamReader(InputStream is) {
            this.is = is;
        }

        @Override
        public void run() {
            try {
                int c;

                while ((c = is.read()) != -1) {
                    sw.write(c);
                }
            }
            catch (IOException e) {
        }
        }

        public String getResult() {
            
            return sw.toString();
        }
    }

}
